import {
  TwindContext
} from "./chunk.XJDNB3KX.js";
import {
  W,
  Ye,
  de
} from "./chunk.7VFLWIC7.js";

// src/runtime/styling/index.ts
import {
  createElement,
  useContext
} from "react";

// node_modules/twind/twind.js
var Te;
var Tt = (e, t) => (typeof t == "function" && (Te = false), t);
var vt = (e) => {
  Te = true;
  let t = JSON.stringify(e, Tt);
  return Te && t;
};
var te = (e, t) => {
  let n = vt(t), r;
  if (n) {
    var i = Ye.get(e);
    i || Ye.set(e, i = new Map()), r = i.get(n);
  }
  return r || (r = Object.defineProperty((o, a2) => (a2 = Array.isArray(o) ? a2 : o, W(e(t, a2), a2)), "toJSON", {value: () => n || t}), i && (i.set(n, r), de(i, 1e4))), r;
};

// node_modules/twind/css/css.js
var m = (e, t = 1) => e.slice(t);
var R = (e) => e.replace(/[A-Z]/g, "-$&").toLowerCase();
var S = (e, t) => {
  for (; typeof e == "function"; )
    e = e(t);
  return e;
};
var l = (e, t, r) => t ? Object.keys(t).reduce((n, s) => {
  let i = S(t[s], r);
  return i && typeof i == "object" && !Array.isArray(i) ? n[s] = l(n[s] || {}, i, r) : n[R(s)] = i, n;
}, e) : e;
var z = typeof CSS != "undefined" && CSS.escape || ((e) => {
  let t = e.charCodeAt(0), r = "";
  return t >= 48 && t <= 57 && (r = "\\" + t.toString(16) + " ", e = m(e)), r + e.replace(/[!./:#]/g, "\\$&");
});
var w = (e, t) => {
  let r = (n, s) => Array.isArray(s) ? s.reduce(r, n) : l(n, S(s, t), t);
  return e.reduce(r, {});
};
var k = /\s*(?:([\w-%@]+)\s*:?\s*([^{;]+?)\s*(?:;|$|})|([^;}{]*?)\s*{)|(})/gi;
var v = /\/\*[\s\S]*?\*\/|\s+|\n/gm;
var f = (e, t) => e.reduceRight((r, n) => ({[n]: r}), t);
var a = (e, t, r) => {
  r && e.push(f(t, r));
};
var M = (e, t, r) => {
  let n = e[0], s = [];
  for (let i = 0; i < t.length; ) {
    let o = S(t[i], r);
    o && typeof o == "object" ? (s.push(n, o), n = e[++i]) : n += (o || "") + e[++i];
  }
  return s.push(n), s;
};
var F = (e) => {
  let t = [], r = [], n, s;
  for (let i = 0; i < e.length; i++) {
    let o = e[i];
    if (typeof o == "string")
      for (; s = k.exec(o.replace(v, " ")); )
        !s[0] || (s[4] && (n = a(r, t, n), t.pop()), s[3] ? (n = a(r, t, n), t.push(s[3])) : s[4] || (n || (n = {}), s[2] && /\S/.test(s[2]) ? n[s[1]] = s[2] : e[++i] && (n[s[1]] = e[i])));
    else
      n = a(r, t, n), r.push(f(t, o));
  }
  return a(r, t, n), r;
};
var c = (e, t) => w(Array.isArray(e[0]) && Array.isArray(e[0].raw) ? F(M(e[0], e.slice(1), t)) : e, t);
var g = (...e) => te(c, e);

// src/runtime/styling/index.ts
function styledComponent(component, parentDirective) {
  return function boundStyled(...args) {
    const directive = g(parentDirective, g(...args));
    return function boundStyledElement(props) {
      return renderStyled(component, props, directive);
    };
  };
}
function styledHtml(elementType, parentDirective) {
  return function boundStyled(...args) {
    const directive = g(parentDirective, g(...args));
    return function boundStyledElement(props) {
      return renderStyled(elementType, props, directive);
    };
  };
}
function renderStyled(elementType, {className, ...props} = {}, directive) {
  const tw = useContext(TwindContext);
  const styledClassName = tw(directive);
  return createElement(elementType, {
    ...props,
    className: `${className ? `${className} ` : ""}${styledClassName}`
  });
}
var styled = new Proxy(renderStyled, {
  apply(_target, _this, [elementType, ...args]) {
    const directive = g(...args);
    return typeof elementType === "string" ? styledHtml(elementType, directive) : styledComponent(elementType, directive);
  },
  get(_t, elementType) {
    return styledHtml(elementType);
  }
});

export {
  styled
};
