import {
  require_prop_types
} from "./chunk.DYBFOFDN.js";
import {
  __commonJS,
  __toModule
} from "./chunk.NFF22PP7.js";

// node_modules/react-fast-compare/index.js
var require_react_fast_compare = __commonJS((exports, module) => {
  var hasElementType = typeof Element !== "undefined";
  var hasMap = typeof Map === "function";
  var hasSet = typeof Set === "function";
  var hasArrayBuffer = typeof ArrayBuffer === "function" && !!ArrayBuffer.isView;
  function equal(a2, b2) {
    if (a2 === b2)
      return true;
    if (a2 && b2 && typeof a2 == "object" && typeof b2 == "object") {
      if (a2.constructor !== b2.constructor)
        return false;
      var length, i2, keys;
      if (Array.isArray(a2)) {
        length = a2.length;
        if (length != b2.length)
          return false;
        for (i2 = length; i2-- !== 0; )
          if (!equal(a2[i2], b2[i2]))
            return false;
        return true;
      }
      var it;
      if (hasMap && a2 instanceof Map && b2 instanceof Map) {
        if (a2.size !== b2.size)
          return false;
        it = a2.entries();
        while (!(i2 = it.next()).done)
          if (!b2.has(i2.value[0]))
            return false;
        it = a2.entries();
        while (!(i2 = it.next()).done)
          if (!equal(i2.value[1], b2.get(i2.value[0])))
            return false;
        return true;
      }
      if (hasSet && a2 instanceof Set && b2 instanceof Set) {
        if (a2.size !== b2.size)
          return false;
        it = a2.entries();
        while (!(i2 = it.next()).done)
          if (!b2.has(i2.value[0]))
            return false;
        return true;
      }
      if (hasArrayBuffer && ArrayBuffer.isView(a2) && ArrayBuffer.isView(b2)) {
        length = a2.length;
        if (length != b2.length)
          return false;
        for (i2 = length; i2-- !== 0; )
          if (a2[i2] !== b2[i2])
            return false;
        return true;
      }
      if (a2.constructor === RegExp)
        return a2.source === b2.source && a2.flags === b2.flags;
      if (a2.valueOf !== Object.prototype.valueOf)
        return a2.valueOf() === b2.valueOf();
      if (a2.toString !== Object.prototype.toString)
        return a2.toString() === b2.toString();
      keys = Object.keys(a2);
      length = keys.length;
      if (length !== Object.keys(b2).length)
        return false;
      for (i2 = length; i2-- !== 0; )
        if (!Object.prototype.hasOwnProperty.call(b2, keys[i2]))
          return false;
      if (hasElementType && a2 instanceof Element)
        return false;
      for (i2 = length; i2-- !== 0; ) {
        if ((keys[i2] === "_owner" || keys[i2] === "__v" || keys[i2] === "__o") && a2.$$typeof) {
          continue;
        }
        if (!equal(a2[keys[i2]], b2[keys[i2]]))
          return false;
      }
      return true;
    }
    return a2 !== a2 && b2 !== b2;
  }
  module.exports = function isEqual(a2, b2) {
    try {
      return equal(a2, b2);
    } catch (error) {
      if ((error.message || "").match(/stack|recursion/i)) {
        console.warn("react-fast-compare cannot handle circular refs");
        return false;
      }
      throw error;
    }
  };
});

// node_modules/invariant/invariant.js
var require_invariant = __commonJS((exports, module) => {
  "use strict";
  var NODE_ENV = process.env.NODE_ENV;
  var invariant = function(condition, format, a2, b2, c2, d2, e2, f2) {
    if (NODE_ENV !== "production") {
      if (format === void 0) {
        throw new Error("invariant requires an error message argument");
      }
    }
    if (!condition) {
      var error;
      if (format === void 0) {
        error = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
      } else {
        var args = [a2, b2, c2, d2, e2, f2];
        var argIndex = 0;
        error = new Error(format.replace(/%s/g, function() {
          return args[argIndex++];
        }));
        error.name = "Invariant Violation";
      }
      error.framesToPop = 1;
      throw error;
    }
  };
  module.exports = invariant;
});

// node_modules/shallowequal/index.js
var require_shallowequal = __commonJS((exports, module) => {
  module.exports = function shallowEqual(objA, objB, compare, compareContext) {
    var ret = compare ? compare.call(compareContext, objA, objB) : void 0;
    if (ret !== void 0) {
      return !!ret;
    }
    if (objA === objB) {
      return true;
    }
    if (typeof objA !== "object" || !objA || typeof objB !== "object" || !objB) {
      return false;
    }
    var keysA = Object.keys(objA);
    var keysB = Object.keys(objB);
    if (keysA.length !== keysB.length) {
      return false;
    }
    var bHasOwnProperty = Object.prototype.hasOwnProperty.bind(objB);
    for (var idx = 0; idx < keysA.length; idx++) {
      var key = keysA[idx];
      if (!bHasOwnProperty(key)) {
        return false;
      }
      var valueA = objA[key];
      var valueB = objB[key];
      ret = compare ? compare.call(compareContext, valueA, valueB, key) : void 0;
      if (ret === false || ret === void 0 && valueA !== valueB) {
        return false;
      }
    }
    return true;
  };
});

// node_modules/react-helmet-async/lib/index.module.js
var import_prop_types = __toModule(require_prop_types());
var import_react_fast_compare = __toModule(require_react_fast_compare());
var import_invariant = __toModule(require_invariant());
var import_shallowequal = __toModule(require_shallowequal());
import e, {Component as t} from "react";
function a() {
  return (a = Object.assign || function(e2) {
    for (var t2 = 1; t2 < arguments.length; t2++) {
      var r2 = arguments[t2];
      for (var n2 in r2)
        Object.prototype.hasOwnProperty.call(r2, n2) && (e2[n2] = r2[n2]);
    }
    return e2;
  }).apply(this, arguments);
}
function s(e2, t2) {
  e2.prototype = Object.create(t2.prototype), e2.prototype.constructor = e2, e2.__proto__ = t2;
}
function c(e2, t2) {
  if (e2 == null)
    return {};
  var r2, n2, i2 = {}, o2 = Object.keys(e2);
  for (n2 = 0; n2 < o2.length; n2++)
    t2.indexOf(r2 = o2[n2]) >= 0 || (i2[r2] = e2[r2]);
  return i2;
}
var u = {BASE: "base", BODY: "body", HEAD: "head", HTML: "html", LINK: "link", META: "meta", NOSCRIPT: "noscript", SCRIPT: "script", STYLE: "style", TITLE: "title", FRAGMENT: "Symbol(react.fragment)"};
var l = Object.keys(u).map(function(e2) {
  return u[e2];
});
var p = {accesskey: "accessKey", charset: "charSet", class: "className", contenteditable: "contentEditable", contextmenu: "contextMenu", "http-equiv": "httpEquiv", itemprop: "itemProp", tabindex: "tabIndex"};
var f = Object.keys(p).reduce(function(e2, t2) {
  return e2[p[t2]] = t2, e2;
}, {});
var d = function(e2, t2) {
  for (var r2 = e2.length - 1; r2 >= 0; r2 -= 1) {
    var n2 = e2[r2];
    if (Object.prototype.hasOwnProperty.call(n2, t2))
      return n2[t2];
  }
  return null;
};
var h = function(e2) {
  var t2 = d(e2, u.TITLE), r2 = d(e2, "titleTemplate");
  if (Array.isArray(t2) && (t2 = t2.join("")), r2 && t2)
    return r2.replace(/%s/g, function() {
      return t2;
    });
  var n2 = d(e2, "defaultTitle");
  return t2 || n2 || void 0;
};
var m = function(e2) {
  return d(e2, "onChangeClientState") || function() {
  };
};
var y = function(e2, t2) {
  return t2.filter(function(t3) {
    return t3[e2] !== void 0;
  }).map(function(t3) {
    return t3[e2];
  }).reduce(function(e3, t3) {
    return a({}, e3, t3);
  }, {});
};
var T = function(e2, t2) {
  return t2.filter(function(e3) {
    return e3[u.BASE] !== void 0;
  }).map(function(e3) {
    return e3[u.BASE];
  }).reverse().reduce(function(t3, r2) {
    if (!t3.length)
      for (var n2 = Object.keys(r2), i2 = 0; i2 < n2.length; i2 += 1) {
        var o2 = n2[i2].toLowerCase();
        if (e2.indexOf(o2) !== -1 && r2[o2])
          return t3.concat(r2);
      }
    return t3;
  }, []);
};
var b = function(e2, t2, r2) {
  var n2 = {};
  return r2.filter(function(t3) {
    return !!Array.isArray(t3[e2]) || (t3[e2] !== void 0 && console && typeof console.warn == "function" && console.warn("Helmet: " + e2 + ' should be of type "Array". Instead found type "' + typeof t3[e2] + '"'), false);
  }).map(function(t3) {
    return t3[e2];
  }).reverse().reduce(function(e3, r3) {
    var i2 = {};
    r3.filter(function(e4) {
      for (var r4, o3 = Object.keys(e4), a2 = 0; a2 < o3.length; a2 += 1) {
        var s3 = o3[a2], c3 = s3.toLowerCase();
        t2.indexOf(c3) === -1 || r4 === "rel" && e4[r4].toLowerCase() === "canonical" || c3 === "rel" && e4[c3].toLowerCase() === "stylesheet" || (r4 = c3), t2.indexOf(s3) === -1 || s3 !== "innerHTML" && s3 !== "cssText" && s3 !== "itemprop" || (r4 = s3);
      }
      if (!r4 || !e4[r4])
        return false;
      var u3 = e4[r4].toLowerCase();
      return n2[r4] || (n2[r4] = {}), i2[r4] || (i2[r4] = {}), !n2[r4][u3] && (i2[r4][u3] = true, true);
    }).reverse().forEach(function(t3) {
      return e3.push(t3);
    });
    for (var o2 = Object.keys(i2), s2 = 0; s2 < o2.length; s2 += 1) {
      var c2 = o2[s2], u2 = a({}, n2[c2], i2[c2]);
      n2[c2] = u2;
    }
    return e3;
  }, []).reverse();
};
var g = function(e2) {
  return Array.isArray(e2) ? e2.join("") : e2;
};
var v = [u.NOSCRIPT, u.SCRIPT, u.STYLE];
var A = function(e2, t2) {
  return t2 === void 0 && (t2 = true), t2 === false ? String(e2) : String(e2).replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#x27;");
};
var C = function(e2) {
  return Object.keys(e2).reduce(function(t2, r2) {
    var n2 = e2[r2] !== void 0 ? r2 + '="' + e2[r2] + '"' : "" + r2;
    return t2 ? t2 + " " + n2 : n2;
  }, "");
};
var O = function(e2, t2) {
  return t2 === void 0 && (t2 = {}), Object.keys(e2).reduce(function(t3, r2) {
    return t3[p[r2] || r2] = e2[r2], t3;
  }, t2);
};
var E = function(t2, r2, n2) {
  switch (t2) {
    case u.TITLE:
      return {toComponent: function() {
        return n3 = r2.titleAttributes, (i2 = {key: t3 = r2.title})["data-rh"] = true, o2 = O(n3, i2), [e.createElement(u.TITLE, o2, t3)];
        var t3, n3, i2, o2;
      }, toString: function() {
        return function(e2, t3, r3, n3) {
          var i2 = C(r3), o2 = g(t3);
          return i2 ? "<" + e2 + ' data-rh="true" ' + i2 + ">" + A(o2, n3) + "</" + e2 + ">" : "<" + e2 + ' data-rh="true">' + A(o2, n3) + "</" + e2 + ">";
        }(t2, r2.title, r2.titleAttributes, n2);
      }};
    case "bodyAttributes":
    case "htmlAttributes":
      return {toComponent: function() {
        return O(r2);
      }, toString: function() {
        return C(r2);
      }};
    default:
      return {toComponent: function() {
        return function(t3, r3) {
          return r3.map(function(r4, n3) {
            var i2, o2 = ((i2 = {key: n3})["data-rh"] = true, i2);
            return Object.keys(r4).forEach(function(e2) {
              var t4 = p[e2] || e2;
              t4 === "innerHTML" || t4 === "cssText" ? o2.dangerouslySetInnerHTML = {__html: r4.innerHTML || r4.cssText} : o2[t4] = r4[e2];
            }), e.createElement(t3, o2);
          });
        }(t2, r2);
      }, toString: function() {
        return function(e2, t3, r3) {
          return t3.reduce(function(t4, n3) {
            var i2 = Object.keys(n3).filter(function(e3) {
              return !(e3 === "innerHTML" || e3 === "cssText");
            }).reduce(function(e3, t5) {
              var i3 = n3[t5] === void 0 ? t5 : t5 + '="' + A(n3[t5], r3) + '"';
              return e3 ? e3 + " " + i3 : i3;
            }, ""), o2 = n3.innerHTML || n3.cssText || "", a2 = v.indexOf(e2) === -1;
            return t4 + "<" + e2 + ' data-rh="true" ' + i2 + (a2 ? "/>" : ">" + o2 + "</" + e2 + ">");
          }, "");
        }(t2, r2, n2);
      }};
  }
};
var S = function(e2) {
  var t2 = e2.bodyAttributes, r2 = e2.encode, n2 = e2.htmlAttributes, i2 = e2.linkTags, o2 = e2.metaTags, a2 = e2.noscriptTags, s2 = e2.scriptTags, c2 = e2.styleTags, l2 = e2.title, p2 = l2 === void 0 ? "" : l2, f2 = e2.titleAttributes;
  return {base: E(u.BASE, e2.baseTag, r2), bodyAttributes: E("bodyAttributes", t2, r2), htmlAttributes: E("htmlAttributes", n2, r2), link: E(u.LINK, i2, r2), meta: E(u.META, o2, r2), noscript: E(u.NOSCRIPT, a2, r2), script: E(u.SCRIPT, s2, r2), style: E(u.STYLE, c2, r2), title: E(u.TITLE, {title: p2, titleAttributes: f2}, r2)};
};
var I = e.createContext({});
var P = import_prop_types.default.shape({setHelmet: import_prop_types.default.func, helmetInstances: import_prop_types.default.shape({get: import_prop_types.default.func, add: import_prop_types.default.func, remove: import_prop_types.default.func})});
var L = typeof document != "undefined";
var x = function(t2) {
  function r2(e2) {
    var n2;
    return (n2 = t2.call(this, e2) || this).instances = [], n2.value = {setHelmet: function(e3) {
      n2.props.context.helmet = e3;
    }, helmetInstances: {get: function() {
      return n2.instances;
    }, add: function(e3) {
      n2.instances.push(e3);
    }, remove: function(e3) {
      var t3 = n2.instances.indexOf(e3);
      n2.instances.splice(t3, 1);
    }}}, r2.canUseDOM || (e2.context.helmet = S({baseTag: [], bodyAttributes: {}, encodeSpecialCharacters: true, htmlAttributes: {}, linkTags: [], metaTags: [], noscriptTags: [], scriptTags: [], styleTags: [], title: "", titleAttributes: {}})), n2;
  }
  return s(r2, t2), r2.prototype.render = function() {
    return e.createElement(I.Provider, {value: this.value}, this.props.children);
  }, r2;
}(t);
x.canUseDOM = L, x.propTypes = {context: import_prop_types.default.shape({helmet: import_prop_types.default.shape()}), children: import_prop_types.default.node.isRequired}, x.defaultProps = {context: {}}, x.displayName = "HelmetProvider";
var j = function(e2, t2) {
  var r2, n2 = document.head || document.querySelector(u.HEAD), i2 = n2.querySelectorAll(e2 + "[data-rh]"), o2 = [].slice.call(i2), a2 = [];
  return t2 && t2.length && t2.forEach(function(t3) {
    var n3 = document.createElement(e2);
    for (var i3 in t3)
      Object.prototype.hasOwnProperty.call(t3, i3) && (i3 === "innerHTML" ? n3.innerHTML = t3.innerHTML : i3 === "cssText" ? n3.styleSheet ? n3.styleSheet.cssText = t3.cssText : n3.appendChild(document.createTextNode(t3.cssText)) : n3.setAttribute(i3, t3[i3] === void 0 ? "" : t3[i3]));
    n3.setAttribute("data-rh", "true"), o2.some(function(e3, t4) {
      return r2 = t4, n3.isEqualNode(e3);
    }) ? o2.splice(r2, 1) : a2.push(n3);
  }), o2.forEach(function(e3) {
    return e3.parentNode.removeChild(e3);
  }), a2.forEach(function(e3) {
    return n2.appendChild(e3);
  }), {oldTags: o2, newTags: a2};
};
var w = function(e2, t2) {
  var r2 = document.getElementsByTagName(e2)[0];
  if (r2) {
    for (var n2 = r2.getAttribute("data-rh"), i2 = n2 ? n2.split(",") : [], o2 = [].concat(i2), a2 = Object.keys(t2), s2 = 0; s2 < a2.length; s2 += 1) {
      var c2 = a2[s2], u2 = t2[c2] || "";
      r2.getAttribute(c2) !== u2 && r2.setAttribute(c2, u2), i2.indexOf(c2) === -1 && i2.push(c2);
      var l2 = o2.indexOf(c2);
      l2 !== -1 && o2.splice(l2, 1);
    }
    for (var p2 = o2.length - 1; p2 >= 0; p2 -= 1)
      r2.removeAttribute(o2[p2]);
    i2.length === o2.length ? r2.removeAttribute("data-rh") : r2.getAttribute("data-rh") !== a2.join(",") && r2.setAttribute("data-rh", a2.join(","));
  }
};
var H = function(e2, t2) {
  var r2 = e2.baseTag, n2 = e2.htmlAttributes, i2 = e2.linkTags, o2 = e2.metaTags, a2 = e2.noscriptTags, s2 = e2.onChangeClientState, c2 = e2.scriptTags, l2 = e2.styleTags, p2 = e2.title, f2 = e2.titleAttributes;
  w(u.BODY, e2.bodyAttributes), w(u.HTML, n2), function(e3, t3) {
    e3 !== void 0 && document.title !== e3 && (document.title = g(e3)), w(u.TITLE, t3);
  }(p2, f2);
  var d2 = {baseTag: j(u.BASE, r2), linkTags: j(u.LINK, i2), metaTags: j(u.META, o2), noscriptTags: j(u.NOSCRIPT, a2), scriptTags: j(u.SCRIPT, c2), styleTags: j(u.STYLE, l2)}, h2 = {}, m2 = {};
  Object.keys(d2).forEach(function(e3) {
    var t3 = d2[e3], r3 = t3.newTags, n3 = t3.oldTags;
    r3.length && (h2[e3] = r3), n3.length && (m2[e3] = d2[e3].oldTags);
  }), t2 && t2(), s2(e2, h2, m2);
};
var k = null;
var M = function(e2) {
  function t2() {
    for (var t3, r3 = arguments.length, n2 = new Array(r3), i2 = 0; i2 < r3; i2++)
      n2[i2] = arguments[i2];
    return (t3 = e2.call.apply(e2, [this].concat(n2)) || this).rendered = false, t3;
  }
  s(t2, e2);
  var r2 = t2.prototype;
  return r2.shouldComponentUpdate = function(e3) {
    return !import_shallowequal.default(e3, this.props);
  }, r2.componentDidUpdate = function() {
    this.emitChange();
  }, r2.componentWillUnmount = function() {
    this.props.context.helmetInstances.remove(this), this.emitChange();
  }, r2.emitChange = function() {
    var e3, t3, r3 = this.props.context, n2 = r3.setHelmet, i2 = null, o2 = (e3 = r3.helmetInstances.get().map(function(e4) {
      var t4 = a({}, e4.props);
      return delete t4.context, t4;
    }), {baseTag: T(["href"], e3), bodyAttributes: y("bodyAttributes", e3), defer: d(e3, "defer"), encode: d(e3, "encodeSpecialCharacters"), htmlAttributes: y("htmlAttributes", e3), linkTags: b(u.LINK, ["rel", "href"], e3), metaTags: b(u.META, ["name", "charset", "http-equiv", "property", "itemprop"], e3), noscriptTags: b(u.NOSCRIPT, ["innerHTML"], e3), onChangeClientState: m(e3), scriptTags: b(u.SCRIPT, ["src", "innerHTML"], e3), styleTags: b(u.STYLE, ["cssText"], e3), title: h(e3), titleAttributes: y("titleAttributes", e3)});
    x.canUseDOM ? (t3 = o2, k && cancelAnimationFrame(k), t3.defer ? k = requestAnimationFrame(function() {
      H(t3, function() {
        k = null;
      });
    }) : (H(t3), k = null)) : S && (i2 = S(o2)), n2(i2);
  }, r2.init = function() {
    this.rendered || (this.rendered = true, this.props.context.helmetInstances.add(this), this.emitChange());
  }, r2.render = function() {
    return this.init(), null;
  }, t2;
}(t);
M.propTypes = {context: P.isRequired}, M.displayName = "HelmetDispatcher";
var N = function(t2) {
  function r2() {
    return t2.apply(this, arguments) || this;
  }
  s(r2, t2);
  var o2 = r2.prototype;
  return o2.shouldComponentUpdate = function(e2) {
    return !import_react_fast_compare.default(this.props, e2);
  }, o2.mapNestedChildrenToProps = function(e2, t3) {
    if (!t3)
      return null;
    switch (e2.type) {
      case u.SCRIPT:
      case u.NOSCRIPT:
        return {innerHTML: t3};
      case u.STYLE:
        return {cssText: t3};
      default:
        throw new Error("<" + e2.type + " /> elements are self-closing and can not contain children. Refer to our API for more information.");
    }
  }, o2.flattenArrayTypeChildren = function(e2) {
    var t3, r3 = e2.child, n2 = e2.arrayTypeChildren;
    return a({}, n2, ((t3 = {})[r3.type] = [].concat(n2[r3.type] || [], [a({}, e2.newChildProps, this.mapNestedChildrenToProps(r3, e2.nestedChildren))]), t3));
  }, o2.mapObjectTypeChildren = function(e2) {
    var t3, r3, n2 = e2.child, i2 = e2.newProps, o3 = e2.newChildProps, s2 = e2.nestedChildren;
    switch (n2.type) {
      case u.TITLE:
        return a({}, i2, ((t3 = {})[n2.type] = s2, t3.titleAttributes = a({}, o3), t3));
      case u.BODY:
        return a({}, i2, {bodyAttributes: a({}, o3)});
      case u.HTML:
        return a({}, i2, {htmlAttributes: a({}, o3)});
      default:
        return a({}, i2, ((r3 = {})[n2.type] = a({}, o3), r3));
    }
  }, o2.mapArrayTypeChildrenToProps = function(e2, t3) {
    var r3 = a({}, t3);
    return Object.keys(e2).forEach(function(t4) {
      var n2;
      r3 = a({}, r3, ((n2 = {})[t4] = e2[t4], n2));
    }), r3;
  }, o2.warnOnInvalidChildren = function(e2, t3) {
    return import_invariant.default(l.some(function(t4) {
      return e2.type === t4;
    }), typeof e2.type == "function" ? "You may be attempting to nest <Helmet> components within each other, which is not allowed. Refer to our API for more information." : "Only elements types " + l.join(", ") + " are allowed. Helmet does not support rendering <" + e2.type + "> elements. Refer to our API for more information."), import_invariant.default(!t3 || typeof t3 == "string" || Array.isArray(t3) && !t3.some(function(e3) {
      return typeof e3 != "string";
    }), "Helmet expects a string as a child of <" + e2.type + ">. Did you forget to wrap your children in braces? ( <" + e2.type + ">{``}</" + e2.type + "> ) Refer to our API for more information."), true;
  }, o2.mapChildrenToProps = function(t3, r3) {
    var n2 = this, i2 = {};
    return e.Children.forEach(t3, function(e2) {
      if (e2 && e2.props) {
        var t4 = e2.props, o3 = t4.children, a2 = c(t4, ["children"]), s2 = Object.keys(a2).reduce(function(e3, t5) {
          return e3[f[t5] || t5] = a2[t5], e3;
        }, {}), l2 = e2.type;
        switch (typeof l2 == "symbol" ? l2 = l2.toString() : n2.warnOnInvalidChildren(e2, o3), l2) {
          case u.FRAGMENT:
            r3 = n2.mapChildrenToProps(o3, r3);
            break;
          case u.LINK:
          case u.META:
          case u.NOSCRIPT:
          case u.SCRIPT:
          case u.STYLE:
            i2 = n2.flattenArrayTypeChildren({child: e2, arrayTypeChildren: i2, newChildProps: s2, nestedChildren: o3});
            break;
          default:
            r3 = n2.mapObjectTypeChildren({child: e2, newProps: r3, newChildProps: s2, nestedChildren: o3});
        }
      }
    }), this.mapArrayTypeChildrenToProps(i2, r3);
  }, o2.render = function() {
    var t3 = this.props, r3 = t3.children, n2 = a({}, c(t3, ["children"]));
    return r3 && (n2 = this.mapChildrenToProps(r3, n2)), e.createElement(I.Consumer, null, function(t4) {
      return e.createElement(M, a({}, n2, {context: t4}));
    });
  }, r2;
}(t);
N.propTypes = {base: import_prop_types.default.object, bodyAttributes: import_prop_types.default.object, children: import_prop_types.default.oneOfType([import_prop_types.default.arrayOf(import_prop_types.default.node), import_prop_types.default.node]), defaultTitle: import_prop_types.default.string, defer: import_prop_types.default.bool, encodeSpecialCharacters: import_prop_types.default.bool, htmlAttributes: import_prop_types.default.object, link: import_prop_types.default.arrayOf(import_prop_types.default.object), meta: import_prop_types.default.arrayOf(import_prop_types.default.object), noscript: import_prop_types.default.arrayOf(import_prop_types.default.object), onChangeClientState: import_prop_types.default.func, script: import_prop_types.default.arrayOf(import_prop_types.default.object), style: import_prop_types.default.arrayOf(import_prop_types.default.object), title: import_prop_types.default.string, titleAttributes: import_prop_types.default.object, titleTemplate: import_prop_types.default.string}, N.defaultProps = {defer: true, encodeSpecialCharacters: true}, N.displayName = "Helmet";

// src/runtime/helmet/index.ts
var defaultHelmetProps = {
  htmlAttributes: {
    lang: "en"
  },
  defaultTitle: "Nostalgie app",
  meta: [
    {
      name: "viewport",
      content: "width=device-width, initial-scale=1"
    },
    {
      name: "description",
      content: "Web app created using Nostalgie"
    }
  ]
};

export {
  defaultHelmetProps,
  x,
  N
};
